#!/usr/bin/env python
# -*- coding: utf-8 -*- 
# vim: ts=4:sw=4
import gtk
import os
import asamalar
import gobject

#home = os.environ["HOME"]       /* Bu değişken bir yer kullanılmıyor */

class sec(gtk.Assistant):
    def __init__(self):
        gtk.Assistant.__init__(self) 

        self.connect('close', gtk.main_quit)
        self.connect('apply',self.kapat)
        self.connect('cancel', gtk.main_quit)

        self.set_title("Ubuntu Tr Betik")        

        self.set_icon_from_file("./logo.png")    
        self.betik = "./betik"
        
        self.eklenenler = []
        self.dict = asamalar.steps
 
        # Her sözlük için yeni bir pencere içerisine scrollView ekleniyor
        for i  in  range(len(self.dict) ):
            sozluk = self.dict[i][1]                        # i. aşama sözlüğü alınıyor
            current_page_title =  "Aşama %s: %s " % (i+1 ,self.dict[i][0] )  # i. aşama için pencere başlığı oluşturuluyor
            current_scroll_view = self.olus_sw(sozluk)                    # ScrollView oluşturuluyor
            self.add_page(current_page_title, current_scroll_view)    
        
 
    	#Son Sayfa
    	vbox = gtk.VBox()
        vbox.set_border_width(50)

    	image = gtk.Image() 
        image.set_from_file("./logo.png")
    	vbox.pack_start(image,True,True,3)
    	
    	button = gtk.CheckButton("Seçim ile işlemleri onayla")      
    	button.connect("clicked",self.comple)  

        vbox.pack_start(button,False,False,3) 
        vbox.show_all()

        self.append_page(vbox)        
        self.set_page_title(vbox,"İşlemi Bitir!" )
        self.set_page_type(vbox, gtk.ASSISTANT_PAGE_CONFIRM)       


    def olus_sw(self, liste):

        sw = gtk.ScrolledWindow() 
        self.view = gtk.TreeView()

        #self.tree_store = gtk.TreeStore(gobject.TYPE_STRING, bool) 
        self.tree_store = gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_BOOLEAN)         
        self.tree_store.set_sort_column_id(0, gtk.SORT_ASCENDING) 
        self.view.set_model(self.tree_store )
 

        self.renderer1 = gtk.CellRendererToggle()
        self.renderer1.set_property('activatable', True)
        self.renderer1.connect( 'toggled', self.col1_toggled_cb, self.tree_store, liste)

        self.column0 = gtk.TreeViewColumn("Seçim", self.renderer1 )           
        self.column0.add_attribute( self.renderer1, "active", 1)                      
 
        self.renderer = gtk.CellRendererText()
        self.column1 = gtk.TreeViewColumn(" Depolar", self.renderer, text=0)  


        # Oluşturulan hücreler ana View'e ekleniyor
        self.view.append_column(self.column0)
        self.view.append_column(self.column1) 
        
 
        for x in liste:
            self.tree_store.append(None, (x, None))

        
        sw.set_policy(True, True)
        sw.add(self.view) 
        return sw


    def add_page(self,page_title, scroll_view) :
        table = gtk.Table(2,2)  
        table.attach(scroll_view,0,1,0,1)
        table.show_all()
        self.append_page(table)        
        self.set_page_title(table, page_title)
        self.set_page_type(table, gtk.ASSISTANT_PAGE_CONTENT)        
        self.set_page_complete(table,True)   



    def comple(self, data): 
        if data.get_active() is True:
            self.set_page_complete(data.get_parent(),True)	  
        else:
            self.set_page_complete(data.get_parent(),False)	                


        
    def col1_toggled_cb( self, cell, path, model ,liste ): 
        model[path][1] = not model[path][1] 
        toggled_item =  liste[(model[path][0])]        

        if  model[path][1]:
            self.eklenenler.append(toggled_item)
        else:
            self.eklenenler.remove(toggled_item)
        return
 
    def kapat(self, assistant):
        text = " ".join(self.eklenenler)   
        #Dosya açıpta yazmaya pek gerek yokmuş 
        #Zamanında çok çektirdi gnome-terminal -e
        #Sıkıntı olursa yine eskiye döneriz
        os.system("""gnome-terminal \
-e './ubuntu-tr-betik {0}' -t 'Ubuntu Tr Betik Kurulum ' \
--hide-menubar  & """.format(text) )
        
    def main(self): self.show()

sec().main()
gtk.main()
